/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VInputPersonrightRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputPersonright extends TableImpl<VInputPersonrightRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_personright</code>
     */
    public static final VInputPersonright V_INPUT_PERSONRIGHT = new VInputPersonright();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputPersonrightRecord> getRecordType() {
        return VInputPersonrightRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_personright.usnr</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> USNR = createField(DSL.name("usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_personright.dn</code>.
     */
    public final TableField<VInputPersonrightRecord, String> DN = createField(DSL.name("dn"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_personright.hier_lang</code>.
     */
    public final TableField<VInputPersonrightRecord, String> HIER_LANG = createField(DSL.name("hier_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_personright.short_name</code>.
     */
    public final TableField<VInputPersonrightRecord, String> SHORT_NAME = createField(DSL.name("short_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_personright.right_mode</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> RIGHT_MODE = createField(DSL.name("right_mode"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_personright.fk_key_element</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> FK_KEY_ELEMENT = createField(DSL.name("fk_key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_personright.form_order</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> FORM_ORDER = createField(DSL.name("form_order"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_input_personright.ignore_closed_visits</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> IGNORE_CLOSED_VISITS = createField(DSL.name("ignore_closed_visits"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_personright.min_obs</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> MIN_OBS = createField(DSL.name("min_obs"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_personright.max_obs</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> MAX_OBS = createField(DSL.name("max_obs"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_personright.user_owns</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> USER_OWNS = createField(DSL.name("user_owns"), SQLDataType.INTEGER, this, "");

    /**
     * The column
     * <code>common_dd.v_input_personright.element_hierachy_stage</code>.
     */
    public final TableField<VInputPersonrightRecord, Integer> ELEMENT_HIERACHY_STAGE = createField(DSL.name("element_hierachy_stage"), SQLDataType.INTEGER, this, "");

    private VInputPersonright(Name alias, Table<VInputPersonrightRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputPersonright(Name alias, Table<VInputPersonrightRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_personright" as  SELECT v_core_login.usnr,
         t_core_element_hierarchy.dn,
         t_core_element_hierarchy.hier_lang,
         t_core_element_hierarchy.short_name,
             CASE t_core_userprivilege.shippie_acl
                 WHEN 'r'::common_dd.enum_accesslevel THEN 1
                 WHEN 'rw'::common_dd.enum_accesslevel THEN 2
                 ELSE NULL::integer
             END AS right_mode,
         t_core_element_hierarchy.key_element AS fk_key_element,
         t_input_webform.form_order,
             CASE t_input_webform.ignore_closed_visits
                 WHEN true THEN 1
                 ELSE 0
             END AS ignore_closed_visits,
         t_input_webform.min_obs,
         t_input_webform.max_obs,
             CASE t_input_webform.user_owns
                 WHEN true THEN 1
                 ELSE 0
             END AS user_owns,
         t_core_element_hierarchy.stage AS element_hierachy_stage
        FROM (((common_dd.v_core_login
          RIGHT JOIN common_dd.t_core_userprivilege ON ((t_core_userprivilege.fk_usnr = v_core_login.usnr)))
          FULL JOIN common_dd.t_core_element_hierarchy ON ((t_core_userprivilege.fk_privilege = t_core_element_hierarchy.fk_privilege)))
          JOIN common_dd.t_input_webform ON ((t_input_webform.fk_form = t_core_element_hierarchy.key_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_personright</code> table
     * reference
     */
    public VInputPersonright(String alias) {
        this(DSL.name(alias), V_INPUT_PERSONRIGHT);
    }

    /**
     * Create an aliased <code>common_dd.v_input_personright</code> table
     * reference
     */
    public VInputPersonright(Name alias) {
        this(alias, V_INPUT_PERSONRIGHT);
    }

    /**
     * Create a <code>common_dd.v_input_personright</code> table reference
     */
    public VInputPersonright() {
        this(DSL.name("v_input_personright"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputPersonright as(String alias) {
        return new VInputPersonright(DSL.name(alias), this);
    }

    @Override
    public VInputPersonright as(Name alias) {
        return new VInputPersonright(alias, this);
    }

    @Override
    public VInputPersonright as(Table<?> alias) {
        return new VInputPersonright(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputPersonright rename(String name) {
        return new VInputPersonright(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputPersonright rename(Name name) {
        return new VInputPersonright(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputPersonright rename(Table<?> name) {
        return new VInputPersonright(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputPersonright where(Condition condition) {
        return new VInputPersonright(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputPersonright where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputPersonright where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputPersonright where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputPersonright where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputPersonright where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputPersonright where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputPersonright where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputPersonright whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputPersonright whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
